package x36paa_batoh;

import java.awt.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

class Graphs extends Canvas {

  private MeasureInterface measure=null;

  public void setMeasure(MeasureInterface measure) {
    this.measure=measure;
    repaint();
  }

  public MeasureInterface getMeasure() {
    return this.measure;
  }

  public void update(Graphics g) {
    paint(g);
  }

  public void paint(Graphics g) {
    g.setColor(Color.WHITE);
    if (measure==null) {
      g.clearRect(0, 0, this.getWidth(), this.getHeight());
      return;
    }
    g.fillRect(0,0,this.getWidth(),this.getHeight());
    g.setColor(Color.LIGHT_GRAY);
    for (int i=0;i<10;i++) {
      g.fillRect(
          0,(i*(this.getHeight()-1))/10,this.getWidth(),1);
    }
    int n=measure.getGraphValuesCount();
    for (int i=0;i<n;i++) {
      g.fillRect(
          (i*(this.getWidth()-1))/(n-1),0,1,this.getHeight());
    }
    int graphs=measure.getCountOfGraph();
    int max=measure.getGraphValuesCount();
    double delta=((double) this.getWidth())/((double) max-1);
    for (int i=0;i<graphs;i++) {
      g.setColor(measure.getGraphColor(i));
      for (int j=1;j<max;j++) {
        g.drawLine(
            (int) ((j-1)*delta),(int) (this.getHeight()*(1.-measure.getGraphValue(i,j-1)))-1,
            (int) ((j)*delta),(int) (this.getHeight()*(1.-measure.getGraphValue(i,j))-1)
            );
      }
    }
    for (int i=0;i<graphs;i++) {
      g.setColor(measure.getGraphColor(i));
      g.drawString(measure.getGraphName(i),0,(i+1)*g.getFont().getSize());
    }
  }

}
