package x36paa_batoh;

import javax.swing.*;
import layout.*;
import javax.swing.table.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class SourceTable extends JPanel implements ActionListener {

  JButton jButton=new JButton("Pidat vc");
  JTextField maxWeight=new JTextField("0.0");
  TableModel tableModel=new TableModel();
  JTable jTable=new JTable();

  public SourceTable() {
    this.setLayout(new TableLayout(new double[][] {
                                   {TableLayout.PREFERRED, TableLayout.FILL, TableLayout.PREFERRED},
                                   {TableLayout.PREFERRED,5,TableLayout.PREFERRED, TableLayout.FILL}
    }));
    this.add(new JLabel("Maximln hmotnost"),"0,0,F,F");
    this.add(maxWeight,"2,0,F,F");
    jButton.addActionListener(this);
    this.add(jButton,"2,2,F,F");
    jTable.setDefaultEditor(JButton.class,new JButtonEditor());
    jTable.setDefaultRenderer(JButton.class,new JButtonRenderer());
    jTable.setModel(tableModel);
    this.add(new JScrollPane(jTable),"0,3,2,3");
  }

  public void actionPerformed(ActionEvent e) {
    tableModel.add();
  }


  public double getMaxWeigth() {
    try {
      return Double.parseDouble(maxWeight.getText());
    } catch (Exception e) {
      e.printStackTrace();
      return 0.;
    }
  }

  public Object[][] getData() {
    return tableModel.getData();
  }

  class TableModel extends AbstractTableModel {

    private Vector<Row> data=new Vector();
    private String[] HEADER_NAME={"Nzev","Hmotnost","Cena",""};
    private JButton jButton=new JButton("Odstra");

    public TableModel() {
      Row row=new Row();
      row.init();
      data.add(row);
    }

    public Object[][] getData() {
      Object out[][]=new Object[data.size()][];
      int i=0;
      for (Row r:data) {
        out[i++]=new Object[] {
                 r.name, r.price, r.weight
        };
      }
      return out;
    }

    public void delete(Object o) {
      delete(data.indexOf(o));
    }

    public void add() {
      data.add(new Row());
      this.fireTableStructureChanged();
    }

    public void delete(int i) {
      if (data.size()>1) {
        data.remove(i);
      } else {
        data.get(0).reset();
      }
      this.fireTableStructureChanged();
    }

    public int getRowCount() {
      return data.size();
    }

    public int getColumnCount() {
      return HEADER_NAME.length;
    }

    public boolean isCellEditable(int rowIndex,int columnIndex) {
      return data.get(rowIndex).isCellEditable(columnIndex);
    }

    public Class getColumnClass(int columnIndex) {
      return (data.size()>0)?data.get(0).getColumnClass(columnIndex):null;
    }

    public String getColumnName(int columnIndex) {
      return HEADER_NAME[columnIndex];
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
      return data.get(rowIndex).getValueAt(columnIndex);
    }

    public void setValueAt(Object o, int rowIndex, int columnIndex) {
      data.get(rowIndex).setValueAt(o,columnIndex);
    }

    class Row implements ActionListener {

      private String name="";
      private Double price=0., weight=0.;

      public void init() {
        jButton.addActionListener(this);
      }

      public void reset() {
        name="";
        price=0.;weight=0.;
      }

      public Object getValueAt(int columnIndex) {
        switch (columnIndex) {
          case 0:
            return name;
          case 1:
            return weight;
          case 2:
            return price;
          case 3:
            return jButton;
        }
        return null;
      }

      public void setValueAt(Object o, int columnIndex) {
        switch (columnIndex) {
          case 0:
            name=(String) o;
            break;
          case 1:
            weight=(Double) o;
            break;
          case 2:
            price=(Double) o;
            break;
          case 3:
            jButton=(JButton) o;
            break;
        }
      }

      public Class getColumnClass(int columnIndex) {
        Object o=this.getValueAt(columnIndex);
        if (o==null) return null;
        return o.getClass();
      }

      public boolean isCellEditable(int columnIndex) {
        return true;
      }

      public void actionPerformed(ActionEvent e) {
        JButtonEditor jbe=(JButtonEditor) jTable.getDefaultEditor(JButton.class);
        delete(jbe.row);
      }
    }
  }

  class JButtonEditor implements TableCellEditor {

    private int row;
    private JButton btn;

    public Object getCellEditorValue() {
      return btn.getText();
    }

    public boolean isCellEditable(EventObject anEvent) {
      return true;
    }

    public boolean shouldSelectCell(EventObject anEvent) {
      return true;
    }

    public synchronized boolean stopCellEditing() {
      return false;
    }

    public synchronized void cancelCellEditing() {
    }

    public synchronized void addCellEditorListener(CellEditorListener l) {
    }

    public synchronized void removeCellEditorListener(CellEditorListener l) {
    }

    public Component getTableCellEditorComponent(JTable table, Object value,
                                                 boolean isSelected, int row,
                                                 int column) {
      this.row=row;
      return btn=(JButton) value;
    }

  }

  class JButtonRenderer implements TableCellRenderer {

    private JButton btn;

    public Component getTableCellRendererComponent(JTable table, Object value,
                                                   boolean isSelected,
                                                   boolean hasFocus, int row,
                                                   int column) {
      btn=(JButton) value;
      return btn;
    }
  }

}
