package x36paa_batoh;

import java.awt.Color;
import java.util.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Measure1 implements MeasureInterface {

  private final double MUL=1.; // nasobeni hodnoty procent .. 1000=>0-0.1%
  private final int COUNT=10, MAX=17; // pocet mereni

  private Graph[] graphs=new Graph[] {new Graph(),new Graph(),new Graph()};

  public Measure1() {
    Random rnd=new Random();
    for (int k=0;k<COUNT;k++) {
      for (int i=1;i<MAX;i++) {
        Object data[][]=new Object[i][3];
        for (int j=0;j<i;j++) {
          data[j][0]="Prvek . " + j;
          data[j][1]=1.+Math.abs(rnd.nextInt()%100);
          data[j][2]=1.+Math.abs(rnd.nextInt()%100);
        }
        double maxWeigth=1.+Math.abs(rnd.nextInt()%500);
        BrutalForce bf=new BrutalForce(data,maxWeigth);
        Heurestic1 h1=new Heurestic1(data,maxWeigth);
        graphs[0].add(i,bf.time);
        graphs[1].add(i,h1.time);
        Double error=1.-h1.price/bf.price;
        if (bf.price==0.) error=0.;
        graphs[2].add(i,error);
      }
    }
    for (int j=0;j<this.getGraphValuesCount();j++) {
      System.out.println((j+1)+"\t"+graphs[0].getAvg(j)+"\t"+graphs[1].getAvg(j));
    }
  }

  public int getCountOfGraph() {
    return 3;
  }

  public String getGraphName(int i) {
    return (new String[] {"Brutln sla [rozsah "+MAX+" prvku x "+COUNT+", "+graphs[0].getMaxAvg()+" ns]","Heurestika cena/hmotnost [rozsah "+MAX+" prvku x "+COUNT+", "+graphs[1].getMaxAvg()+" ns]","Max. relativn chyba bs/hch [rozsah "+(1./(MUL/100))+"%]"})[i];
  }

  public Color getGraphColor(int i) {
    return (new Color[] {Color.RED, Color.BLUE, Color.GREEN})[i];
  }

  public double getGraphMaxValue(int i) {
    if (i<2) {
      double a=graphs[0].getMax(), b=graphs[1].getMax();
      return a>b?a:b;
    } return graphs[i].getMax();
  }

  public int getGraphValuesCount() {
    return graphs[0].size();
  }

  public double getGraphValue(int graph, int position) {
    int id=graphs[graph].getId(position);
    if (graph<2) {
      double max=graphs[0].getMaxAvg(),max2=graphs[1].getMaxAvg();
      return graphs[graph].getAvg(id)/((max<max2)?max2:max);
    }
    return graphs[2].getMax(id)*MUL;
  }

}
