package x36paa_batoh;

import java.util.Random;
import java.awt.Color;
import java.util.*;
import javax.swing.filechooser.*;
import java.io.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
class Measure2 implements MeasureInterface {

  private final double MUL=1.; // nasobeni hodnoty procent .. 1000=>0-0.1%

  private Graph[] graphs=new Graph[] {new Graph(),new Graph(),new Graph(),new Graph()};

  public Measure2() {
    Vector<File> out=new Vector();
    FileSystemView sys=FileSystemView.getFileSystemView();
    File[] x=sys.getFiles(new File("data"),true);
    for (File f:x) {
      if (f.isFile()) {
        if (f.getName().indexOf("_r.")<0) {
          out.add(f);
        }
      }
    }
    Collections.sort(out);
    for (File f:out) {
      try {
        FileReader fr=new FileReader(f);
        BufferedReader br=new BufferedReader(fr);
        FileReader fr_r=new FileReader(new File(f.getAbsolutePath().replaceAll("\\.","_r.")));
        BufferedReader br_r=new BufferedReader(fr_r);
        double opt=0., heu1=0., count=0.;
        int n=0;
        while (br.ready()) {
          String values[]=br.readLine().split(" ");
          n=Integer.parseInt(values[1]);
          Object data[][]=new Object[n][];
          int j=3;
          for (int i=0;i<n;i++) {
            Double a=Double.parseDouble(values[j++]);
            Double b=Double.parseDouble(values[j++]);
            data[i]=new Object[] {"Poloka "+i,b,a};
          }
          Heurestic1 h1=new Heurestic1(data,Double.parseDouble(values[2]));
          double optimal=Double.parseDouble(br_r.readLine().split(" ")[2]);
          graphs[0].add(n,optimal);
          graphs[1].add(n,h1.price);
          graphs[2].add(n,optimal-h1.price);
          graphs[3].add(n,(optimal-h1.price)/optimal);
          opt+=optimal;
          heu1+=h1.price;
          count+=1.;
//          System.out.println(values[0]+"\t"+n+"\t"+h1.price+"\t"+optimal);
        }
        System.out.println(n+"\t"+(heu1/count)+"\t"+(opt/count));
      } catch (Exception e) {
        e.printStackTrace();
      }
    }
    for (Graph g:graphs) {
      g.sort();
    }
  }

  public int getCountOfGraph() {
    return 6;
  }

  public String getGraphName(int i) {
    return (new String[] {
            "Optimln een",
            "Heurestika cena/hmotnost",
            "Prmrn absolutn chyba",
            "Max. absolutn chyba",
            "Prmrn relativn chyba [rozsah "+(1./(MUL/100))+"%]",
            "Max. relativn chyba [rozsah "+(1./(MUL/100))+"%]"})[i];
  }

  public Color getGraphColor(int i) {
    return (new Color[] {
            Color.RED,
            Color.BLUE,
            Color.GREEN,
            Color.YELLOW,
            Color.PINK,
            Color.BLACK})[i];
  }

  public double getGraphMaxValue(int i) {
    switch (i) {
      case 0: case 1: case 2: case 3: return Math.max(graphs[0].getMax(), Math.max(graphs[1].getMax(),graphs[2].getMax()));
      case 4: return graphs[3].getMaxAvg();
      case 5: return graphs[3].getMax();
    }
    return 0.;
  }

  public int getGraphValuesCount() {
    return graphs[0].size();
  }

  public double getGraphValue(int graph, int position) {
    int graphId=graph<2?graph:(graph<4?2:3);
    int id=graphs[graphId].getId(position);
    if (graph<4) {
      double max=Math.max(graphs[0].getMaxAvg(),Math.max(graphs[1].getMaxAvg(),graphs[2].getMax()));
      if (graph==3) return graphs[2].getMax(id)/max;
      return graphs[graph].getAvg(id)/max;
    }
    if (graph==4) return graphs[3].getAvg(id)*MUL; //prum. realtivni odchylka
    return graphs[3].getMax(id)*MUL; //max. relativni odchylka
  }

}
